#!/usr/bin/env python

import sys,types,socket,string,exceptions
try:
	from cStringIO import StringIO
except:
	from StringIO import StringIO

from manipulator import *


######################################################################
#
######################################################################

class istream_var:
	
	def __init__(self,type):
		if not type in ['string','int','float','double']:
			raise exceptions.RuntimeError,'Illegal type for istream_var constructor: %s' % type

		self.value 	= None
		self.type	= type


	def __str__(self):
		return str(self.value)


	def __rrshift__(self,istream_inst):
		if not isinstance(istream_inst,istream):
			raise exceptions.RuntineError,'left hand argument is not an istream instance'

		self.value = istream_inst.get_value()
		return istream_inst




######################################################################
#
######################################################################

class istream:

	def __init__(self):
		self.fp 	= None
		self.data	= StringIO()

	def get_value(self):
		data = self.fp.read()
		return data

	def __rshift__(self,arg):
		if not isinstance(arg,istream_var):
			raise exceptions.RuntimeError,'variable must instance of istream_var'	

		arg.__rrshift__(self)


class FileIstream(istream):
	
	def __init__(self,fname=None,fp=None):
		istream.__init__(self)

		if fname != None:
			self.fp = open(fname,'r')
		
		elif fp != None:
			self.fp = fp

		else:
			self.fp	= sys.stdin




if __name__=='__main__':


	s= istream_var('string')
	x=FileIstream(fname='sux.out')
	x >> s	
	print s
