#!/usr/bin/env python

import exceptions

######################################################################
# Manipulator class
######################################################################

class MANIPULATOR:
	def __init__(self,type,output):
		self.type	= type
		self.output = output
		self.value  = None

	def __str__(self):		return self.output
	def __repr__(self):		return self.output

	def __call__(self,arg):
		if not self.type in ['precision','setw','setfill']:
			raise exceptions.RuntimeError,'%s is not a callable manipulator' % self.type

		self.value	= arg
		return self


endl 			= MANIPULATOR('endl', '\n')
ends 			= MANIPULATOR('ends','%c' % 0)
_hex  			= MANIPULATOR('hex',None)
_dec  			= MANIPULATOR('dec',None)
_oct  			= MANIPULATOR('oct',None)
_boolalpha  	= MANIPULATOR('bollalpha',None)
_noboolalpha  	= MANIPULATOR('noboolalpha',None)
_flush			= MANIPULATOR('flush',None)
fixed			= MANIPULATOR('fixed',None)
scientific		= MANIPULATOR('scientific',None)
setprecision	= MANIPULATOR('precision',None)
uppercase		= MANIPULATOR('uppercase',None)
nouppercase		= MANIPULATOR('nouppercase',None)
setw			= MANIPULATOR('setw',None)
setfill			= MANIPULATOR('setfill',None)


